local ShadowUF = ShadowUF
local Five = {}

ShadowUF:RegisterModule(Five, "fiveOverlay", "5 Second Rule")

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, addon)
	if IsAddOnLoaded("ShadowedUnitFrames_Five") then
		self:UnregisterEvent("ADDON_LOADED")
		ShadowUF.db.profile.units.player.fiveOverlay = {enabled = true}
	end
end)

local mana_regen_wait = 5 -- okay, okay, this is unlikely to change. BUT!
local function updateFiveSecondRule(bar, t)
	local timediff = GetTime() - bar.spellcast_finish_time
	if timediff > mana_regen_wait then
		-- it's been more than five seconds, get rid of the spark
		bar:Hide()
	else
		-- move the spark a little
		bar.texture:SetPoint('LEFT', bar, 'LEFT', (timediff / mana_regen_wait) * (bar:GetWidth() - 1) - 10, 0)
	end	
end

function Five:OnEnable(frame, unit)
	if unit ~= "player" then
		return
	end
	local _, playerClass = UnitClass(unit)
	if playerClass == "WARRIOR" or playerClass == "ROGUE" or playerClass == "DEATHKNIGHT" then
		return
	end
	
	if not frame.fiveOverlay then
		frame.fiveOverlay = CreateFrame("Frame", frame)
		frame.fiveOverlay:SetScript("OnUpdate", updateFiveSecondRule)

		local texture = frame.fiveOverlay:CreateTexture(nil, "OVERLAY")
		texture:SetPoint("LEFT", frame.fiveOverlay)
		texture:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		texture:SetVertexColor(1, 1, 1, 0.6) -- config this?
		texture:SetBlendMode('ADD')
		texture:SetWidth(20)
		texture:Show()
		frame.fiveOverlay.texture = texture

		frame.fiveOverlay.current_mana = UnitMana(unit)
		frame.fiveOverlay.spellcast_finish_time = 0
		frame.fiveOverlay.last_spellcast = 0
	end
	
	frame:RegisterUnitEvent("UNIT_MANA", self, "UnitMana")
	frame:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", self, "CastSucceeded")
	if playerClass == "DRUID" then
		frame:RegisterUnitEvent("UNIT_DISPLAYPOWER", self, "DisplayPower")
	end
end

function Five:OnLayoutApplied(frame)
	if not frame.fiveOverlay or not frame.powerBar then
		return
	end
	
	frame.fiveOverlay:SetAllPoints(frame.powerBar)
	frame.fiveOverlay:SetFrameStrata(frame.powerBar:GetFrameStrata())
	frame.fiveOverlay:SetFrameLevel(frame.powerBar:GetFrameLevel() + 1)
	frame.fiveOverlay:Hide()
end

function Five:OnDisable(frame, unit)
	frame:UnregisterAll(self)
end

function Five:UnitMana(frame, event, unit)
	if unit ~= "player" then return end
	local mana = UnitMana(unit)
	if mana == UnitManaMax(unit) then
		frame.fiveOverlay:Hide()
	elseif mana < frame.fiveOverlay.current_mana then
		frame.fiveOverlay.spellcast_finish_time = frame.fiveOverlay.last_spellcast
		frame.fiveOverlay:Show()
	end
	frame.fiveOverlay.current_mana = mana
end

function Five:CastSucceeded(frame, event, unit)
	if unit ~= "player" then return end
	frame.fiveOverlay.last_spellcast = GetTime()
end

function Five:DisplayPower(frame, event, unit)
	if unit ~= "player" then return end
	if UnitPowerType(unit) == 0 then
		frame.fiveOverlay:Hide()
	else
		frame.fiveOverlay.current_mana = UnitMana(unit)
		frame.fiveOverlay:Show()
	end
end

